#ifndef _DUMMY_MSG_H_
#define _DUMMY_MSG_H_
#pragma once
/****
MARCO to run unpack and dump function.
****/
//unpack static response and run dump function
#define UNPACK_STATIC_RESP_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen) \
{\
    if(eRSP==respmsg[0])\
    {\
        unpackfn##_t unpackfn##var; \
        memset(&unpackfn##var,0,sizeof(unpackfn##var));\
        UNPACK_RESP_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,&unpackfn##var)\
    }\
    else \
    {\
        fprintf(stderr,"Not resp %s:%d\n",__FUNCTION__,__LINE__); fflush(stderr); \
        resultcode = eQCWWAN_ERR_INVALID_QMI_RSP;\
    }\
}

#define _UNPACK_MSG_AND_DUMP(resptype,resultcode,unpackfn,dunpfn,respmsg,resplen,argpt) \
    _UNPACK_MSG(resptype,resultcode,unpackfn,respmsg,resplen,argpt);\
    if ( (eQCWWAN_ERR_NONE == resultcode) || \
          ( (resptype == eIND) && \
             (eQCWWAN_ERR_QMI_OFFSET == resultcode)) )\
    {\
        {dunpfn(argpt);}\
        swi_uint256_print_mask((argpt)->ParamPresenceMask);\
    }

#define UNPACK_RESP_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,argpt) \
    _UNPACK_MSG_AND_DUMP(eRSP,resultcode,unpackfn,dunpfn,respmsg,resplen,argpt);\

#define _UNPACK_MSG(resptype,resultcode,unpackfn,respmsg,resplen,argpt) \
{\
    if(respmsg[0]==resptype)\
    {\
        resultcode = unpackfn(respmsg, resplen, argpt); \
        swi_uint256_print_mask((argpt)->ParamPresenceMask);\
    }\
    else\
    {\
        if(resptype==eRSP)\
        {fprintf(stderr,"Not resp %s:%d",__FUNCTION__,__LINE__); fflush(stderr);} \
        if(resptype==eIND)\
        {fprintf(stderr,"Not ind %s:%d",__FUNCTION__,__LINE__); fflush(stderr);} \
        resultcode = eQCWWAN_ERR_INVALID_QMI_RSP;\
    }\
}
#define UNPACK_RESP(resultcode,unpackfn,respmsg,resplen,argpt) \
        _UNPACK_MSG(eRSP,resultcode,unpackfn,respmsg,resplen,argpt)

#define UNPACK_IND_RESP(resultcode,unpackfn,respmsg,resplen,argpt) \
        _UNPACK_MSG(eIND,resultcode,unpackfn,respmsg,resplen,argpt)

//unpack indication with unpack struct and run dump function
#define UNPACK_STATIC_IND_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen) \
{\
    if(eIND==respmsg[0])\
    {\
        unpackfn##_t unpackfn##var; \
        memset(&unpackfn##var,0,sizeof(unpackfn##var));\
        _UNPACK_MSG_AND_DUMP(eIND,resultcode,unpackfn,dunpfn,respmsg,resplen,&unpackfn##var);\
    }\
    else \
    {\
        fprintf(stderr,"Not Ind %s:%d\n",__FUNCTION__,__LINE__); fflush(stderr); \
        resultcode = eQCWWAN_ERR_INVALID_QMI_RSP;\
    }\
}

#define _UNPACK_IND_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,argunpack,argdump,argprintmask) \
{\
    if(eIND==respmsg[0])\
    {\
        resultcode = unpackfn(respmsg, resplen, argunpack); \
        if (eQCWWAN_ERR_NONE == resultcode) \
        {\
            {dunpfn(argdump);}\
            swi_uint256_print_mask((argprintmask)->ParamPresenceMask);\
        }\
        else \
        { \
            fprintf(stderr,"unpack failed(%d) %s:%d\n",resultcode,__FUNCTION__,__LINE__); fflush(stderr); \
        } \
    }\
    else\
    {\
        fprintf(stderr,"Not ind %s:%d\n",__FUNCTION__,__LINE__); fflush(stderr); \
        resultcode = eQCWWAN_ERR_INVALID_QMI_RSP;\
    }\
}

#define UNPACK_IND_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,pargpt) \
    _UNPACK_IND_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,pargpt,pargpt,pargpt)
#define UNPACK_IND_AND_DUMP_NON_PTR_ARG(resultcode,unpackfn,dunpfn,respmsg,resplen,argpt) \
    _UNPACK_IND_AND_DUMP(resultcode,unpackfn,dunpfn,respmsg,resplen,&argpt,argpt,&argpt)

#define UNPACK_STATIC_AND_NON_STATIC_IND_AND_DUMP_NON_PTR_ARG(resultcode,unpackfn,unpacktype,dunpfn,respmsg,resplen,argpt) \
    if(eIND==respmsg[0])\
    {\
        unpacktype unpacktype##var; \
        memset(&unpacktype##var,0,sizeof(unpacktype));\
        UNPACK_IND_AND_DUMP_NON_PTR_ARG( \
           resultcode,\
           unpackfn,\
           dunpfn,\
           respmsg,\
           resplen,\
           unpacktype##var \
           );\
    }\
    UNPACK_IND_AND_DUMP_NON_PTR_ARG(\
       resultcode,\
       unpackfn,\
       dunpfn,\
       respmsg,\
       resplen,\
       argpt);


#define TEST_IND_UNPACK_DUMP_NON_PTR_ARG(unpackfn,dumpfn,argunpack,...)\
    TEST_IND_UNPACK_WITH_TYPE_DUMP_NON_PTR_ARG(unpackfn,unpackfn##_t,dumpfn,argunpack,__VA_ARGS__);

#define TEST_IND_UNPACK_WITH_TYPE_DUMP_NON_PTR_ARG(unpackfn,unpacktype,dumpfn,argunpack,...)\
{\
    int resultcode = 0;\
    int index = 0;\
    uint8_t dummy_ind_msg[][QMI_MSG_MAX] = __VA_ARGS__  ;\
    int loopCount = sizeof(dummy_ind_msg)/sizeof(dummy_ind_msg[0]);\
    for(index=0;index<loopCount;index++)\
    {\
        uint16_t length =  dummy_ind_msg[index][5] + dummy_ind_msg[index][6]*256 + 7;\
        UNPACK_STATIC_AND_NON_STATIC_IND_AND_DUMP_NON_PTR_ARG(\
            resultcode,\
            unpackfn,\
            unpacktype,\
            dumpfn,\
            dummy_ind_msg[index],\
            length,\
            argunpack\
        );   \
    }\
}

#define TEST_LOC_IND_UNPACK TEST_IND_UNPACK_DUMP_NON_PTR_ARG

#define UNPACK_STATIC_AND_NON_STATIC_IND_AND_DUMP(resultcode,unpackfn,unpacktype,dunpfn,respmsg,resplen,pargpt) \
    if(eIND==respmsg[0])\
    {\
       unpacktype unpacktype##var; \
       memset(&unpacktype##var,0,sizeof(unpacktype));\
       UNPACK_IND_AND_DUMP(\
       resultcode,\
       unpackfn,\
       dunpfn,\
       respmsg,\
       resplen,\
       &unpacktype##var);\
    }\
    UNPACK_IND_AND_DUMP(\
       resultcode,\
       unpackfn,\
       dunpfn,\
       respmsg,\
       resplen,\
       pargpt);

#define TEST_IND_UNPACK_DUMP(unpackfn,dumpfn,argunpack,...)\
    TEST_IND_UNPACK_WITH_TYPE_DUMP(unpackfn,unpackfn##_t,dumpfn,argunpack,__VA_ARGS__)\

#define TEST_IND_UNPACK_WITH_TYPE_DUMP(unpackfn,unpacktype,dumpfn,pargpt,...)\
{\
    int resultcode = 0;\
    int index = 0;\
    uint8_t dummy_ind_msg[][QMI_MSG_MAX] = __VA_ARGS__  ;\
    int loopCount = sizeof(dummy_ind_msg)/sizeof(dummy_ind_msg[0]);\
    for(index=0;index<loopCount;index++)\
    {\
        uint16_t length =  dummy_ind_msg[index][5] + dummy_ind_msg[index][6]*256 + 7;\
        UNPACK_STATIC_AND_NON_STATIC_IND_AND_DUMP(\
            resultcode,\
            unpackfn,\
            unpacktype,\
            dumpfn,\
            dummy_ind_msg[index],\
            length,\
            pargpt\
        );\
    }\
}

/********
Dummy byte strings.
*********/
/** NAS **/
#define DUMMY_UNPACK_NAS_SLQSSYSINFOCALLBACK_IND_MSG \
{\
    0x04,0x01,0x00,0x4e,0x00,0x19,0x01,0x10,0x02,0x00,0xF0,0xE1,0x11,0x02,\
    0x00,0xE0,0xD1,0x12,0x03,0x00,0xD0,0xC1,0xB2,0x13,0x03,0x00,0xB0,0xA1,\
    0x92,0x14,0x03,0x00,0x90,0x81,0x72,0x15,0x2a,0x00,0x00,0x01,0x02,0x03,\
    0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,\
    0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,\
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x16,0x1f,0x00,0x00,\
    0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,\
    0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,\
    0x1d,0x1e,0x17,0x1e,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,\
    0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,\
    0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x18,0x21,0x00,0x00,0x01,0x02,0x03,\
    0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,\
    0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,\
    0x20,0x19,0x1d,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,\
    0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,\
    0x18,0x19,0x1a,0x1b,0x1c,0x1a,0x04,0x00,0x00,0x01,0x02,0x03,0x1b,0x02,\
    0x00,0x00,0x01,0x1c,0x06,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x1d,0x06,\
    0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x1e,0x02,0x00,0x00,0x01,0x1f,0x08,\
    0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x20,0x08,0x00,0x00,0x01,\
    0x02,0x03,0x04,0x05,0x06,0x07,0x21,0x01,0x00,0x00,0x22,0x01,0x00,0x00,\
    0x23,0x01,0x00,0x00,0x24,0x01,0x00,0x00\
},\
{\
    0x04,0x06,0x00,0x4e,0x00,0x6d,0x00,0x13,\
    0x03,0x00,0x01,0x03,0x00,0x14,0x03,0x00,\
    0x00,0x00,0x00,0x18,0x21,0x00,0x01,0x00,\
    0x01,0x03,0x01,0x01,0x01,0x00,0x01,0x9a,\
    0x1f,0x01,0xbf,0xb1,0x09,0x00,0x00,0x00,\
    0x00,0x01,0x34,0x35,0x34,0x30,0x36,0xff,\
    0x01,0x00,0x01,0x03,0x01,0x3c,0x01,0x1d,\
    0x06,0x00,0xff,0xff,0x01,0x00,0x00,0x00,\
    0x20,0x08,0x00,0x01,0x00,0x00,0x00,0x01,\
    0x00,0x00,0x00,0x23,0x01,0x00,0x00,0x24,\
    0x01,0x00,0x01,0x28,0x04,0x00,0x00,0x00,\
    0x00,0x00,0x29,0x01,0x00,0x03,0x2e,0x01,\
    0x00,0x01,0x30,0x04,0x00,0x00,0x00,0x00,\
    0x00,0x33,0x04,0x00,0x00,0x00,0x00,0x00,\
    0x48,0x01,0x00,0x01\
},\

/*** VOICE ***/
#define DUMMY_UNPACK_VOICE_VOICEINFORECCALLBACK_IND_MSG \
{\
    0x04,0x01,0x00,0x26,0x00,0x04,0x00,0x01,0x01,0x00,0x01\
},\
{\
    0x04,0x01,0x00,0x26,0x00,0xe0,0x00,0x01,0x01,0x00,0x01,\
    0x10,0x03,0x00,0x01,0x02,0x03,0x11,0x17,0x00,0x00,0x15,\
    0x43,0x61,0x6c,0x6c,0x65,0x72,0x20,0x49,0x44,0x20,0x49,\
    0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x12,\
    0x14,0x00,0x44,0x69,0x73,0x70,0x6c,0x61,0x79,0x20,0x49,\
    0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x00,\
    0x13,0x1d,0x00,0x45,0x78,0x74,0x65,0x6e,0x64,0x65,0x64,\
    0x20,0x44,0x69,0x73,0x70,0x6c,0x61,0x79,0x20,0x49,0x6e,\
    0x66,0x6f,0x72,0x6d,0x61,0x74,0x69,0x6f,0x6e,0x00,0x14,\
    0x18,0x00,0x43,0x61,0x6c,0x6c,0x65,0x72,0x20,0x4e,0x61,\
    0x6d,0x65,0x20,0x49,0x6e,0x66,0x6f,0x72,0x6d,0x61,0x74,\
    0x69,0x6f,0x6e,0x00,0x15,0x01,0x00,0x01,0x16,0x0f,0x00,\
    0x0f,0x03,0x07,0x0f,0x0a,0x43,0x61,0x6c,0x6c,0x65,0x72,\
    0x20,0x49,0x44,0x00,0x17,0x12,0x00,0x0f,0x03,0x07,0x0f,\
    0x0d,0x31,0x37,0x20,0x43,0x61,0x6c,0x6c,0x65,0x72,0x20,\
    0x49,0x44,0x00,0x18,0x12,0x00,0x0f,0x03,0x07,0x0f,0x0d,\
    0x31,0x38,0x20,0x43,0x61,0x6c,0x6c,0x65,0x72,0x20,0x49,\
    0x44,0x00,0x19,0x13,0x00,0x0f,0x03,0x07,0x0f,0x0c,0x0d,\
    0x31,0x39,0x20,0x43,0x61,0x6c,0x6c,0x65,0x72,0x20,0x49,\
    0x44,0x00,0x1a,0x01,0x00,0x05,0x1b,0x02,0x00,0xb1,0x1b,\
    0x1c,0x01,0x00,0xc1,0x1d,0x04,0x00,0x00,0x01,0x02,0x03\
}
#define DUMMY_VOICE_SUPSNOTIFICATIONCALLBACK_IND_MSG \
{\
    0x04,0x01,0x00,0x32,0x00,0x05,0x00,0x01,0x02,0x00,0x01,0x12\
},\
{\
    0x04,0x02,0x00,0x32,0x00,0x2b,0x00,0x01,0x02,0x00,0x01,0x12,\
    0x10,0x02,0x00,0x10,0x01,0x11,0x1e,0x00,0x02,0x04,0x19,0x4e,\
    0x75,0x6d,0x62,0x65,0x72,0x20,0x69,0x6e,0x20,0x41,0x53,0x43,\
    0x49,0x49,0x20,0x63,0x68,0x61,0x72,0x61,0x63,0x74,0x65,0x72,\
    0x73,0x00 \
}

/*** LOC ***/
#define DUMMY_LOC_GNSSSVINFO_IND_MSG \
{\
    0x04,0x01,0x00,0x25,0x00,0x94,0x00,\
    0x01,0x01,0x00,0x04,0x10,0x8d,0x00,\
    0x05,0x01,0x02,0x03,0x04,0x05,0x06,\
    0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,\
    0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,\
    0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,\
    0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,\
    0x23,0x24,0x25,0x26,0x27,0x28,0x29,\
    0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,\
    0x31,0x32,0x33,0x34,0x35,0x36,0x37,\
    0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,\
    0x3f,0x40,0x41,0x42,0x43,0x44,0x45,\
    0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,\
    0x4d,0x4e,0x4f,0x50,0x51,0x52,0x53,\
    0x54,0x55,0x56,0x57,0x58,0x59,0x5a,\
    0x5b,0x5c,0x5d,0x5e,0x5f,0x60,0x61,\
    0x62,0x63,0x64,0x65,0x66,0x67,0x68,\
    0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,\
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,\
    0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,\
    0x7e,0x7f,0x80,0x81,0x82,0x83,0x84,\
    0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c\
},\
{\
    0x04,0x02,0x00,0x25,0x00,0x04,0x00,0x01,0x01,0x00,0x01\
},\
{\
    0x04,0x03,0x00,0x25,0x00,0x80,0x05,0x01,0x01,0x00,0x04,\
    0x10,0x79,0x05,0x32,0x01,0x02,0x03,0x04,0x05,0x06,0x07,\
    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,\
    0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,\
    0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,\
    0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,\
    0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,\
    0x3f,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,\
    0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0x53,0x54,\
    0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,\
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,\
    0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,0x73,0x74,0x75,\
    0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,0x80,\
    0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,\
    0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,0x96,\
    0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,0xa0,0xa1,\
    0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,\
    0xad,0xae,0xaf,0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,\
    0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,0xc0,0xc1,0xc2,\
    0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,\
    0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,\
    0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,0xe0,0xe1,0xe2,0xe3,\
    0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,\
    0xef,0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,\
    0xfa,0xfb,0xfc,0xfd,0xfe,0xff,0x00,0x01,0x02,0x03,0x04,\
    0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,\
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,\
    0x1b,0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,\
    0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,\
    0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,\
    0x3c,0x3d,0x3e,0x3f,0x40,0x41,0x42,0x43,0x44,0x45,0x46,\
    0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,\
    0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,\
    0x5d,0x5e,0x5f,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,\
    0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,\
    0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,\
    0x7e,0x7f,0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,\
    0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,\
    0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,\
    0x9f,0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,\
    0xaa,0xab,0xac,0xad,0xae,0xaf,0xb0,0xb1,0xb2,0xb3,0xb4,\
    0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,\
    0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,\
    0xcb,0xcc,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,\
    0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,0xe0,\
    0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,\
    0xec,0xed,0xee,0xef,0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,\
    0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,0x00,0x01,\
    0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,\
    0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,\
    0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,\
    0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,\
    0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,\
    0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x40,0x41,0x42,0x43,\
    0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,\
    0x4f,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,\
    0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,0x60,0x61,0x62,0x63,0x64,\
    0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,\
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,\
    0x7b,0x7c,0x7d,0x7e,0x7f,0x80,0x81,0x82,0x83,0x84,0x85,\
    0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,\
    0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,\
    0x9c,0x9d,0x9e,0x9f,0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,\
    0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,0xb0,0xb1,\
    0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,\
    0xbd,0xbe,0xbf,0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,\
    0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,\
    0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,\
    0xde,0xdf,0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,\
    0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,0xf0,0xf1,0xf2,0xf3,\
    0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,\
    0xff,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,\
    0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0x14,\
    0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,\
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,\
    0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,0x35,\
    0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x40,\
    0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,\
    0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0x53,0x54,0x55,0x56,\
    0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,0x60,0x61,\
    0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,\
    0x6d,0x6e,0x6f,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,\
    0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,0x80,0x81,0x82,\
    0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,\
    0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,\
    0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,0xa0,0xa1,0xa2,0xa3,\
    0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,\
    0xaf,0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,\
    0xba,0xbb,0xbc,0xbd,0xbe,0xbf,0xc0,0xc1,0xc2,0xc3,0xc4,\
    0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,\
    0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,\
    0xdb,0xdc,0xdd,0xde,0xdf,0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,\
    0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,0xf0,\
    0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,\
    0xfc,0xfd,0xfe,0xff,0x00,0x01,0x02,0x03,0x04,0x05,0x06,\
    0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,0x11,\
    0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,\
    0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,\
    0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,\
    0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,\
    0x3e,0x3f,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,\
    0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,0x51,0x52,0x53,\
    0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,\
    0x5f,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,\
    0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,0x72,0x73,0x74,\
    0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,\
    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,\
    0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,0x95,\
    0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,0xa0,\
    0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,\
    0xac,0xad,0xae,0xaf,0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,\
    0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,0xc0,0xc1,\
    0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,\
    0xcd,0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,\
    0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,0xe0,0xe1,0xe2,\
    0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,\
    0xee,0xef,0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,\
    0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,0x00,0x01,0x02,0x03,\
    0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,\
    0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,\
    0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,\
    0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,\
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,\
    0x3b,0x3c,0x3d,0x3e,0x3f,0x40,0x41,0x42,0x43,0x44,0x45,\
    0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,0x50,\
    0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,\
    0x5c,0x5d,0x5e,0x5f,0x60,0x61,0x62,0x63,0x64,0x65,0x66,\
    0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,0x70,0x71,\
    0x72,0x73,0x74,0x75,0x76,0x77,0x78\
},\


#define DUMMY_LOC_BESTAVAILPOS_IND_MSG \
{\
    0x04,0x01,0x00,0x67,0x00,0xdc,0x00,0x01,0x04,0x00,\
    0x01,0x02,0x03,0x04,0x10,0x04,0x00,0x11,0x12,0x13,0x14,\
    0x11,0x08,0x00,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,\
    0x12,0x08,0x00,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,\
    0x13,0x04,0x00,0x13,0x14,0x15,0x16,0x14,0x04,0x00,0x14,\
    0x15,0x16,0x17,0x15,0x04,0x00,0x15,0x16,0x17,0x18,0x16,\
    0x08,0x00,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x17,\
    0x04,0x00,0x17,0x18,0x19,0x1a,0x18,0x04,0x00,0x17,0x18,\
    0x19,0x1a,0x19,0x04,0x00,0x17,0x18,0x19,0x1a,0x1a,0x04,\
    0x00,0x17,0x18,0x19,0x1a,0x1b,0x01,0x00,0x00,0x1c,0x01,\
    0x00,0x00,0x1d,0x04,0x00,0x00,0x01,0x02,0x03,0x1e,0x04,\
    0x00,0x00,0x01,0x02,0x03,0x1f,0x04,0x00,0x00,0x01,0x02,\
    0x03,0x20,0x04,0x00,0x00,0x01,0x02,0x03,0x21,0x01,0x00,\
    0x00,0x22,0x04,0x00,0x00,0x01,0x02,0x03,0x23,0x04,0x00,\
    0x00,0x01,0x02,0x03,0x24,0x04,0x00,0x00,0x01,0x02,0x03,\
    0x25,0x04,0x00,0x00,0x01,0x02,0x03,0x26,0x04,0x00,0x00,\
    0x01,0x02,0x03,0x27,0x04,0x00,0x00,0x01,0x02,0x03,0x28,\
    0x04,0x00,0x00,0x01,0x02,0x03,0x29,0x04,0x00,0x00,0x01,\
    0x02,0x03,0x2a,0x04,0x00,0x00,0x01,0x02,0x03,0x2b,0x04,\
    0x00,0x00,0x01,0x02,0x03,0x2c,0x04,0x00,0x00,0x01,0x02,\
    0x03,0x2d,0x04,0x00,0x00,0x01,0x02,0x03\
 },\

#define DUMMY_LOC_INJECTSENSORDATACALLBACK_IND_MSG \
{\
    0x04,0x1,0x00,0x4d,0x00,0x1e,0x00,0x01,0x04,0x00,\
    0x01,0x02,0x03,0x04,0x10,0x04,0x00,0x11,0x12,0x13,0x14,\
    0x11,0x01,0x00,0x11,0x12,0x01,0x00,0x12,0x13,0x01,0x00,\
    0x13,0x14,0x01,0x00,0x14\
},\
{\
    0x04,0x01,0x00,0x4d,0x00,0x1e,0x00,0x01,0x04,0x00,0x01,0x02,\
    0x03,0x01,0x10,0x04,0x00,0x10,0x11,0x12,0x13,0x11,0x01,0x00,\
    0x11,0x12,0x01,0x00,0x21,0x13,0x01,0x00,0x31,0x14,0x01,0x00,0x41\
},\

#define DUMMY_LOC_GETSERVER_IND_MSG \
{\
    0x04,0x01,0x00,0x43,0x00,0x46,0x00,0x01,0x04,\
    0x00,0xF0,0xF1,0xF2,0xF3,0x02,0x04,0x00,0xE0,\
    0xE1,0xE2,0xE3,0x10,0x06,0x00,0xA0,0xA1,0xA2,\
    0xA3,0xB4,0xB5,0x11,0x14,0x00,0xB0,0xB1,0xB2,\
    0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBa,0xBb,\
    0xBc,0xBd,0xBe,0xBf,0xC1,0xC2,0xC3,0xC4,0x12,\
    0x15,0x00,0x77,0x77,0x77,0x2e,0x73,0x69,0x65,\
    0x72,0x72,0x61,0x77,0x69,0x72,0x65,0x73,0x73,\
    0x2e,0x63,0x6f,0x6d,0x00\
 },\

#define DUMMY_LOC_POSITIONRPT_IND_MSG \
{\
    0x04,0x01,0x00,0x24,0x00,0xf3,0x00,0x01,0x04,0x00,0x01,0x02,\
    0x03,0x04,0x02,0x01,0x00,0x02,0x10,0x08,0x00,0x10,0x11,0x12,0x13,\
    0x14,0x15,0x16,0x17,0x11,0x08,0x00,0x11,0x12,0x13,0x14,0x15,0x16,\
    0x17,0x18,0x12,0x04,0x00,0x12,0x13,0x14,0x15,0x13,0x04,0x00,0x12,\
    0x13,0x14,0x15,0x14,0x04,0x00,0x12,0x13,0x14,0x15,0x15,0x04,0x00,\
    0x12,0x13,0x14,0x15,0x16,0x01,0x00,0x00,0x17,0x04,0x00,0x00,0x01,\
    0x02,0x03,0x18,0x04,0x00,0x10,0x11,0x12,0x13,0x19,0x04,0x00,0x20,\
    0x21,0x22,0x23,0x1a,0x04,0x00,0xa0,0xa1,0xa2,0xa3,0x1b,0x04,0x00,\
    0xb0,0xb1,0xb2,0xb3,0x1c,0x04,0x00,0xc0,0xc1,0xc2,0xc3,0x1d,0x01,\
    0x00,0x0d,0x1e,0x04,0x00,0xe0,0xe1,0xe2,0xe3,0x1f,0x04,0x00,0xf0,\
    0xf1,0xf2,0xf3,0x20,0x04,0x00,0x20,0x21,0x22,0x23,0x22,0x04,0x00,\
    0x21,0x22,0x23,0x24,0x23,0x04,0x00,0x23,0x24,0x25,0x26,0x24,0x0c,\
    0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,\
    0x25,0x08,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x26,0x01,\
    0x00,0x62,0x27,0x08,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,\
    0x28,0x04,0x00,0x00,0x01,0x02,0x03,0x29,0x04,0x00,0x20,0x21,0x22,\
    0x23,0x2a,0x08,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x2b,\
    0x04,0x00,0x00,0x01,0x02,0x03,0x2c,0x11,0x00,0x08,0x01,0x02,0x03,\
    0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x10,\
    0x2d,0x01,0x00,0xd2\
},\

#define DUMMY_LOC_SENSORSTREAMINGCALLBACK_IND_MSG \
{\
    0x04,0x01,0x00,0x2e,0x00,0x20,0x00,0x10,0x05,0x00,0x01,0x02,\
    0x03,0x04,0x05,0x11,0x05,0x00,0x11,0x12,0x13,0x14,0x15,0x12,\
    0x05,0x00,0x21,0x22,0x23,0x24,0x25,0x13,0x05,0x00,0x31,0x32,\
    0x33,0x34,0x35\
},\


#endif
